#ifdef __RCS_ID__
 static char rcsid[] = "$Header: /u3/bammi/freeunix/src/RCS/initscr.c,v 1.2 89/03/05 17:58:32 bammi Exp $";
#endif
/*
 * $Log:	initscr.c,v $
 * Revision 1.2  89/03/05  17:58:32  bammi
 * Ansiization. Some fixes. All output via vprint functions
 * 
 * Revision 1.1  89/03/05  17:22:16  bammi
 * Source distribution from SUG tape. See File README for permissions
 * 
 *
 */

/*
 * Copyright 1980 Kenneth C. R. C. Arnold and The Regents of the
 * University of California.  Permission is granted to freely
 * distribute curses and its documentation provided that this
 * notice is left intact.
 */

#ifndef lint
static char sccsid[] = "@(#)initscr.c	5.1 (Berkeley) 6/7/85";
#endif not lint

# include	"curses.ext"
# include	<signal.h>

#ifdef __STDC__
char	*getenv(const char *);
#else
extern char	*getenv();
#endif

/*
 *	This routine initializes the current and standard screen.
 *
 */
WINDOW *
initscr() {

	reg char	*sp;
#ifdef __STDC__
	void		tstp(void);
#else
	int		tstp();
#endif
#ifdef ATARI_ST
	int 		nfd = NFILES;
#else
	int		nfd = 20;	/* ?? */
#endif

# ifdef DEBUG
	fprintf(outf, "INITSCR()\n");
# endif
	if (My_term)
		setterm(Def_term);
	else {
		for (_tty_ch = 0; _tty_ch < nfd; _tty_ch++)
			if (isatty(_tty_ch))
				break;
		gettmode();
		if ((sp = getenv("TERM")) == NULL)
			sp = Def_term;
		setterm(sp);
# ifdef DEBUG
		fprintf(outf, "INITSCR: term = %s\n", sp);
# endif
	}
	_puts(TI);
	_puts(VS);
# ifdef SIGTSTP
	signal(SIGTSTP, tstp);
# endif
	if (curscr != NULL) {
# ifdef DEBUG
		fprintf(outf, "INITSCR: curscr = 0%o\n", curscr);
# endif
		delwin(curscr);
	}
# ifdef DEBUG
	fprintf(outf, "LINES = %d, COLS = %d\n", LINES, COLS);
# endif
	if ((curscr = newwin(LINES, COLS, 0, 0)) == ERR)
		return ERR;
	clearok(curscr, TRUE);
	curscr->_flags &= ~_FULLLINE;
	if (stdscr != NULL) {
# ifdef DEBUG
		fprintf(outf, "INITSCR: stdscr = 0%o\n", stdscr);
# endif
		delwin(stdscr);
	}
	stdscr = newwin(LINES, COLS, 0, 0);
	return stdscr;
}
